<script setup lang="ts">
    import { graphql } from "./../gql/index";
    import { computed, ref } from "vue";
    import { useRouter } from "vue-router";
    import useNavigationStore from "./../stores/navigation";
    import { useQuery } from "@vue/apollo-composable";
    import { VDataTable } from "vuetify/components/VDataTable";
    import { participantQueryString, tooltipText } from "./query";
    import { pushToClipboard } from "../functions/clipboard";
    import { DynamicRoutePaths } from "../plugins/router";

    const router = useRouter();
    const search = ref("");
    const navigationStore = useNavigationStore();

    // Participants search query
    const participantsSearch = graphql(`
        query ParticipantsSearch {
            allParticipants {
                id
                familyName
                callName
                sex
                extensions {
                    emailSelf
                    additionalEmails
                    contacts {
                        telephone
                    }
                }
            }
        }
    `);
    const { result } = useQuery(participantsSearch, null, {
        fetchPolicy: "cache-and-network",
    });
    const participants = computed(() => {
        const res = result.value?.allParticipants! ?? [];
        let out = [] as {
            id: string;
            callName: string;
            familyName: string;
            queryString: string;
        }[];

        res.forEach((participant) => {
            if (participant.callName != "REDACTED" && participant.familyName != "REDACTED") {
                out.push({
                    id: participant.id,
                    callName: participant.callName,
                    familyName: participant.familyName,
                    queryString: participantQueryString(participant, null),
                });
            }
        });

        return out;
    });

    const headers = [
        {
            align: "start",
            key: "callName",
            sortable: true,
            title: "Vorname",
        },
        {
            key: "familyName",
            sortable: true,
            title: "Familienname",
        },
        {
            key: "id",
            sortable: false,
            title: "",
        },
        {
            key: "queryString",
            sortable: false,
            title: "",
        },
    ];

    function showParticipant(id: string) {
        navigationStore.participantId = id;
        router.push({ name: DynamicRoutePaths.ParticipantDetails }); // TODO move this out possibly
    }

    const tableExport = ref([] as { columns: { callName: string; id: string; familyName: string; queryString: string } }[]);
    const copyTable = function () {
        let out = "";

        tableExport.value.forEach((row) => {
            out += [row.columns.id, row.columns.callName, row.columns.familyName, row.columns.queryString].join("\t");
            out += "\n";
        });

        pushToClipboard(out);
    };
    const handleTableChange = function (currItems: any) {
        tableExport.value = currItems;
    };
</script>

<template>
    <div class="pa-3">
        <h2 class="text-center">Teilnehmer-Suche</h2>

        <v-card title="Teilnehmer" variant="tonal" class="my-2">
            <template v-slot:text>
                <v-tooltip location="top">
                    <template v-slot:activator="{ props }">
                        <v-text-field
                            v-model="search"
                            append-icon="mdi-magnify"
                            label="Search"
                            single-line
                            hide-details
                            class="mb-2"
                            v-bind="props"
                        ></v-text-field>
                    </template>
                    <span>{{ tooltipText }}</span>
                </v-tooltip>
                <v-data-table
                    :headers="(headers as any)"
                    :items="participants"
                    :search="search"
                    multi-sort
                    @update:current-items="handleTableChange"
                >
                    <template v-slot:item.id="{ item }">
                        <v-btn size="small" @click="showParticipant(item.id)">
                            <template v-slot:prepend> <span class="material-symbols-outlined"> search </span></template>
                            Teilnehmer anzeigen
                        </v-btn>
                    </template>
                    <template v-slot:item.queryString="{}"> </template>
                </v-data-table>
                <br />
                <v-btn @click="copyTable">
                    <template v-slot:prepend> <span class="material-symbols-outlined"> backup_table </span></template>
                    Tabelle Kopieren
                </v-btn>
            </template>
        </v-card>
    </div>
</template>
